from MuVisitor import MuVisitor
from MuParser import *
from math import *
from enum import Enum

class BaseType(Enum):
    Float, Integer, Boolean, String, Nil = range(5)

    def printBaseType(self):
        print (self)

        
class MyMuTypingVisitor(MuVisitor):

    def __init__(self):
        self._memorytypes = dict() #id-> types

    #visitors for atoms --> value

    def visitParExpr(self,ctx):
        return self.visit(ctx.expr())

    def visitNumberAtom(self,ctx):
        s = ctx.getText();
        try:
            int(s)
            return BaseType.Integer
        except ValueError:
            try:
                float(s)
                return BaseType.Float
            except:
                raise SyntaxError("Invalid number atom")

    def visitBooleanAtom(self, ctx): #implement!
        pass  

    def visitIdAtom(self,ctx): #implement!
        pass

    def visitStringAtom(self,ctx):
        pass

    def visitNilAtom(self,ctx): 
        pass

    #now visit expr

    def visitAtomExpr(self,ctx):
        return self.visit(ctx.atom())

    def visitOrExpr(self,ctx): #implement!
        pass


    def visitAndExpr(self,ctx): #implement
        pass

    def visitEqualityExpr(self,ctx):
        return self.visitRelationalExpr(ctx)

    def visitRelationalExpr(self,ctx): #implement!
        pass

    def visitAdditiveExpr(self,ctx):  #implement!
        pass
    
    def visitMultiplicationExpr(self,ctx): #implement!
        pass
    
    def visitnotExpr(self,ctx): #implement!
        pass
    
    def visitUnaryMinusExpr(selt,ctx):#implement!
        pass

    def visitPowEpr(self,ctx):#implement!
        pass

    def visitOpPlus(self,ctx):
        return ctx.getText();

    def visitOpMul(self,ctx):
        return ctx.getText();

    def visitOpRel(self,ctx):
        return ctx.getText();

    def visitOpEq(self,ctx):
        return ctx.getText();

#statements -

    def visitAssignStat(self,ctx):#implement!
        pass
    
    def visitCondBlock(self,ctx):#implement!
        pass 
        
    def visitWhileStat(self,ctx):#implement!
        pass
