from AritVisitor import AritVisitor
from AritParser import *

class MyAritVisitor(AritVisitor):
        # Visit a parse tree produced by AritParser#int.
    def visitInt(self, ctx):
        value = int(ctx.getText());
        return value;
    
    def visitMultiplicationExpr(self, ctx):
        leftval = self.visit(ctx.expr(0))
        rightval =  self.visit(ctx.expr(1))
        myop = self.visit(ctx.mdop())
        if ( myop == '*'):
            return leftval*rightval
        else:
            return leftval/rightval
        
    def visitMdop(self, ctx): #todo, je pense qu'on peut faire + elegant
        return ctx.getText()

    def visitPmop(self, ctx): #todo, je pense qu'on peut faire + elegant
        return ctx.getText()

    
        
    def visitAdditiveExpr(self, ctx):
        leftval = self.visit(ctx.expr(0))
        rightval = self.visit(ctx.expr(1))
        if ( self.visit(ctx.pmop()) == '+'):
            return leftval+rightval
        else:
            return leftval-rightval


    def visitPrintExpr(self, ctx):
        val =  self.visit(ctx.expr())
        print('The value is '+str(val))

